﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace RandomNumbers
{
    interface IRandomGenerator
    {
        int ReturnNextRandom(int maxIndex);
    }

    class RandomGenerator : IRandomGenerator
    {
        private static Random _rnd = new Random();
        private static object _lock = new object();

        public int ReturnNextRandom(int maxIndex)
        {
            return Next(maxIndex); 
        }

        private int Next(int maxIndex)
        {
            lock (_lock)
            {
               return _rnd.Next(maxIndex);
            }
        }
    }
}
